#include <stdio.h>
#include <assert.h>

#include "Schorr-Waite.h"

static ptr Next;

const ptr Null = 0;

cel Memory[100];

unsigned is_left(ptr pointer)
  { return ((unsigned)pointer - (unsigned)Memory) / sizeof(cel) % 2; }

static cel car(cel cons)
  { assert(cons.T == p);
    return *cons.P; }

static cel cdr(cel cons)
  { assert(cons.T == p);
    return *(cons.P + 1); }

static void set_car(cel cons, cel car)
  { assert(cons.T == p);
    *cons.P = car; }

static void set_cdr(cel cons, cel cdr)
  { assert(cons.T == p);
    *(cons.P + 1) = cdr; }

static cel cons(cel car, cel cdr)
  { cel hold = { Next, p, u};
    *Next++ = car;
    *Next++ = cdr;
    return hold; }

static void show(void)
  { printf("memory:");
    for (ptr p = Memory; p < Next; p += 1)
      printf("\n   *%5d = [ %5d , %d , %d ]", (unsigned)p, (unsigned)p->P, p->T, p->M);
    printf("\n\n"); }

int main(int argc, const char * argv[])
  { cel A, B, C, D, E, F, G;

    cel _11  = { (ptr)11, a, u };
    cel _12  = { (ptr)12, a, u };
    cel _13  = { (ptr)13, a, u };
    cel _14  = { (ptr)14, a, u };
    cel _15  = { (ptr)15, a, u };
    cel _21  = { (ptr)21, a, u };
    cel _22  = { (ptr)22, a, u };
    cel _31  = { (ptr)31, a, u };
    cel _32  = { (ptr)32, a, u };
    cel _33  = { (ptr)33, a, u };
    cel _34  = { (ptr)34, a, u };
    cel _35  = { (ptr)35, a, u };
    cel _41  = { (ptr)41, a, u };
    cel _42  = { (ptr)42, a, u };
    cel _43  = { (ptr)43, a, u };

    Next = Memory + 1;

    A = cons(_11, _12);
    B = cons(_13, cons(_14, _15));
    C = cons(_21, _22);
    D = cons(_31 , B);
    E = cons(_32, _33);
    F = cons(E, cons(_34, B));
    set_car(cdr(F), cdr(cdr(cdr(D))));
    G = cons(_35, cons(_41, cons(_42, _43)));
    show();
    Schorr_Waite(F);
    show(); }
